local buffx = -450
local buffy = 258
local GrowUp = true
local BACKGROUNDTEX = "Interface\\AddOns\\mLootRoll\\blank"

----------------------------------------
--Roll Frame Backgrounds
----------------------------------------
for i = 1, NUM_GROUP_LOOT_FRAMES do
	local contname = "GroupLootFrame"..i
	local bagbg = CreateFrame("Frame", nil, _G[contname])	
	bagbg:SetFrameStrata("low")
	bagbg:SetPoint("TOPRIGHT", contname, "TOPRIGHT", -2, -22)
	bagbg:SetPoint("BOTTOMLEFT", contname, "BOTTOMLEFT", 5, 22)	
	bagbg:SetBackdrop( { 
	  bgFile = BACKGROUNDTEX, 
	  edgeFile = BACKGROUNDTEX, 
	  tile = false, tileSize = 0, edgeSize = 1, 
	  insets = { left = -1, right = -1, top = -1, bottom = -1 }
	})
	bagbg:SetBackdropColor(0.1,0.1,0.1,1)
	bagbg:SetBackdropBorderColor(0.6,0.6,0.6,1)
end
-------------------------------------
--no confirmation dialog for greed/DE
-------------------------------------
local f = CreateFrame("Frame")
f:RegisterEvent("CONFIRM_DISENCHANT_ROLL")
f:RegisterEvent("CONFIRM_LOOT_ROLL")
f:SetScript("OnEvent", function(self, event, id, rollType)
	for i=1,STATICPOPUP_NUMDIALOGS do
		local frame = _G["StaticPopup"..i]
		if frame.which == "CONFIRM_LOOT_ROLL" and frame.data == id and frame.data2 == rollType and frame:IsVisible() then StaticPopup_OnClick(frame, 1) end
	end
end)

-----------------------------
--Dont Show the Dungeon Complete Frame
-----------------------------
AlertFrame:UnregisterEvent("LFG_COMPLETION_REWARD")
-----------------------------
--Switch Between Greed/Disenchant Buttons on Shift
-----------------------------
local togglestuff = CreateFrame("Frame", nil, UIParent)
togglestuff:SetScript("OnEvent", function() actiontogglez() end)
function actiontogglez()
	if ( IsShiftKeyDown() ) then 
		for i =1, NUM_GROUP_LOOT_FRAMES do
			_G["GroupLootFrame"..i.."DisenchantButton"]:SetAlpha(1)
			--_G["GroupLootFrame"..i.."DisenchantButton"]:SetFrameStrata("DIALOG")
			_G["GroupLootFrame"..i.."PassButton"]:SetAlpha(1)
			--_G["GroupLootFrame"..i.."PassButton"]:SetFrameStrata("DIALOG")
			--_G["GroupLootFrame"..i.."GreedButton"]:SetAlpha(0)
			--_G["GroupLootFrame"..i.."GreedButton"]:SetFrameStrata("low")
			--_G["GroupLootFrame"..i.."RollButton"]:SetAlpha(0)
			--_G["GroupLootFrame"..i.."RollButton"]:SetFrameStrata("low")
			_G["GroupLootFrame"..i.."RollButton"]:Hide()
			_G["GroupLootFrame"..i.."GreedButton"]:Hide()
		end
	else
		for i =1, NUM_GROUP_LOOT_FRAMES do
			--_G["GroupLootFrame"..i.."RollButton"]:SetFrameStrata("DIALOG")
			--_G["GroupLootFrame"..i.."PassButton"]:SetFrameStrata("low")
			--_G["GroupLootFrame"..i.."GreedButton"]:SetFrameStrata("DIALOG")
			--_G["GroupLootFrame"..i.."DisenchantButton"]:SetFrameStrata("low")
			_G["GroupLootFrame"..i.."DisenchantButton"]:SetAlpha(0)
			_G["GroupLootFrame"..i.."PassButton"]:SetAlpha(0)
			--_G["GroupLootFrame"..i.."GreedButton"]:SetAlpha(1)
			--_G["GroupLootFrame"..i.."RollButton"]:SetAlpha(1)
			_G["GroupLootFrame"..i.."RollButton"]:Show()
			_G["GroupLootFrame"..i.."GreedButton"]:Show()
		end
	end
end
togglestuff:RegisterEvent("MODIFIER_STATE_CHANGED")
---------------------------------------------
--Hide & Position Loot Roll Frames on Startup
---------------------------------------------
local frame = CreateFrame("Frame", "mLootRollAnchor", UIParent)	
frame:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", buffx, buffy)

frame:SetWidth(GroupLootFrame1:GetWidth())
frame:SetHeight(GroupLootFrame1:GetHeight())

frame:EnableMouse(true)
frame:SetMovable(true)
frame:RegisterForDrag("LeftButton")
frame:SetScript("OnDragStart", function() this:StartMoving() end )
frame:SetScript("OnDragStop", function() this:StopMovingOrSizing() end )
frame:SetBackdrop({
		bgFile = "Interface/Tooltips/UI-Tooltip-Background",
		edgeFile = nil,
		tile = true,
		tileSize = 16,
		edgeSize = 16,
		insets = { left = 10, right = 10, top = 18, bottom = 20 }
})
frame:SetBackdropColor(0.6,0.6,0.6,1)
frame:SetScript("OnMouseDown", function() if arg1 == "RightButton" then
			mLootRollAnchor:Hide()
			mlootposition = {mLootRollAnchor:GetRight(), mLootRollAnchor:GetBottom()}
		end
	end)

function hiderollregionz(self, event, id)
	for i=1, NUM_GROUP_LOOT_FRAMES do
		frame = _G["GroupLootFrame" .. i]
		frame:ClearAllPoints()
		if i == 1 then
			frame:SetPoint("BOTTOMLEFT", mLootRollAnchor, "BOTTOMLEFT", 4, 2)
		elseif GrowUp == true then
			frame:SetPoint("BOTTOM", "GroupLootFrame" .. (i-1), "TOP", 0, -10)
		else
			frame:SetPoint("TOP", "GroupLootFrame" .. (i-1), "BOTTOM", 0, 10)
		end			
		frame:SetParent(UIParent)
							
		local x=({frame:GetRegions()})
		for j =1, 5 do
			x[j]:SetAlpha(0)
		end
		x[3]:SetAlpha(1)
		x[3]:SetText("Thunderfury, Blessed Blade of the Windseeker")		
		x[3]:SetFont("Fonts\\ARIALN.ttf", 12, "OVERLAY")
		x[3]:SetHeight(12)
		x[3]:ClearAllPoints()
		x[3]:SetPoint("LEFT",frame,"LEFT",80, 10)
		
		local x=({frame:GetRegions()})
			x[3]:SetWidth(frame:GetRight() - frame:GetLeft() - 10)
			frame:SetWidth(x[3]:GetStringWidth()+90)
		
		local y = ({_G["GroupLootFrame"..i.."Timer"]:GetRegions()})
		y[1]:SetAlpha(0)
		frame:SetBackdrop(nil)		
		_G["GroupLootFrame"..i.."PassButton"]:ClearAllPoints()
		_G["GroupLootFrame"..i.."PassButton"]:SetPoint("TOPLEFT", frame, "TOPLEFT", 45, -5)
		_G["GroupLootFrame"..i.."PassButton"]:SetAlpha(0)
		_G["GroupLootFrame"..i.."PassButton"]:SetNormalTexture("Interface\\Buttons\\UI-GroupLoot-Pass-Up")
		_G["GroupLootFrame"..i.."PassButton"]:SetPushedTexture("Interface\\Buttons\\UI-GroupLoot-Pass-Up")

		_G["GroupLootFrame"..i.."DisenchantButton"]:ClearAllPoints()
		_G["GroupLootFrame"..i.."DisenchantButton"]:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 44, 5)
		_G["GroupLootFrame"..i.."DisenchantButton"]:SetAlpha(0)

		_G["GroupLootFrame"..i.."GreedButton"]:ClearAllPoints()
		_G["GroupLootFrame"..i.."GreedButton"]:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 44, 5)

		_G["GroupLootFrame"..i.."RollButton"]:ClearAllPoints()
		_G["GroupLootFrame"..i.."RollButton"]:SetPoint("TOPLEFT", frame, "TOPLEFT", 45, -10)

		_G["GroupLootFrame"..i.."RollButton"]:SetFrameStrata("DIALOG")
		_G["GroupLootFrame"..i.."GreedButton"]:SetFrameStrata("DIALOG")
		_G["GroupLootFrame"..i.."DisenchantButton"]:SetFrameStrata("low")
		_G["GroupLootFrame"..i.."PassButton"]:SetFrameStrata("low")

		_G["GroupLootFrame"..i.."Timer"]:ClearAllPoints()
		_G["GroupLootFrame"..i.."Timer"]:SetPoint("LEFT", frame, "LEFT", 80, -8)
		_G["GroupLootFrame"..i.."Timer"]:SetStatusBarColor(0.2, 1, 0.2)
		_G["GroupLootFrame"..i.."Timer"]:SetValue(60000) -- for debugging colorz
		_G["GroupLootFrame"..i.."IconFrame"]:ClearAllPoints()
		_G["GroupLootFrame"..i.."IconFrame"]:SetPoint("LEFT", frame, "LEFT", 7, 0)
		mLootRollAnchor:Hide()
	end
end

local eventFrame = CreateFrame("Frame", nil, UIParent)
eventFrame:RegisterEvent("PLAYER_ENTERING_WORLD");
eventFrame:SetScript("OnEvent",  hiderollregionz)
------------------------------
--When a LootRollStarts
------------------------------
function printname(self, id)	
	for i=1, NUM_GROUP_LOOT_FRAMES do
		frame = _G["GroupLootFrame" .. i]		
		if frame:IsShown() then
			local x=({frame:GetRegions()})
			x[3]:SetWidth(frame:GetRight() - frame:GetLeft() - 10)
			frame:SetWidth(x[3]:GetStringWidth()+90)
			_G["GroupLootFrame"..i.."Timer"]:SetWidth(x[3]:GetStringWidth())
			frame:SetBackdrop(nil)			
			_G["GroupLootFrame"..i.."DisenchantButton"]:SetAlpha(0)
		end
	end
	actiontogglez()
end
local eventFrame2 = CreateFrame("Frame", nil, UIParent)
eventFrame2:RegisterEvent("START_LOOT_ROLL")
eventFrame2:SetScript("OnEvent", function(self, event, id)  printname(self, id) end)

---------------------
--Slasch cmd
---------------------

SLASH_mlootrollmove1 = "/mlr"

SlashCmdList["mlootrollmove"] = function() mLootRollAnchor:Show() end 
